/* for noen forferdelige greier */
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

typedef struct {
	int texid;
	int type;
	int width,height;
	GLubyte*image;
} texture;
texture textures[5];
#define bindtex(a) glBindTexture(GL_TEXTURE_2D, textures[a].texid)
int aktiv = 0;
unsigned int tack = 0;
float rut;

void display(void)
{
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

	glLoadIdentity();
	glTranslatef(5.0-rut/500, 0.0, -2.0);
	glEnable(GL_TEXTURE_2D);
	bindtex(0);
	glRotatef(sin(rut/10)*10, 0.0, 0.0, 1.0);
	glBegin(GL_QUADS);
	glTexCoord2f(0.0, 0.0); glVertex3f(-1.2, 1.1, 0.0);
	glTexCoord2f(1.0, 0.0); glVertex3f( 1.2, 1.1, 0.0);
	glTexCoord2f(1.0, 1.0); glVertex3f( 1.2,-1.1, 0.0);
	glTexCoord2f(0.0, 1.0); glVertex3f(-1.2,-1.1, 0.0);
	glEnd();

	if(rut/333 > 4.0 && rut/333 < 10) {
		glLoadIdentity();
		glTranslatef(0.0, 2.0, -2.0);
		bindtex(1);
		glBegin(GL_QUADS);
		glTexCoord2f(0.0, 0.0); glVertex3f(-1.2, 0.2, 0.0);
		glTexCoord2f(1.0, 0.0); glVertex3f( 1.2, 0.2, 0.0);
		glTexCoord2f(1.0, 1.0); glVertex3f( 1.2,-0.2, 0.0);
		glTexCoord2f(0.0, 1.0); glVertex3f(-1.2,-0.2, 0.0);
		glEnd();
	}

	if(rut/333 > 10) {
		glLoadIdentity();
		glTranslatef(0.0, 0.0, -3.0+sin(rut/20)*2);
		if(rut/333 > 11) {
			glLoadIdentity();
			glTranslatef(0.0, 0.0, -2.0);
		}
		bindtex(2);
		glBegin(GL_QUADS);
		glTexCoord2f(0.0, 0.0); glVertex3f(-1.0, 1.0, 0.0);
		glTexCoord2f(1.0, 0.0); glVertex3f( 1.0, 1.0, 0.0);
		glTexCoord2f(1.0, 1.0); glVertex3f( 1.0,-1.0, 0.0);
		glTexCoord2f(0.0, 1.0); glVertex3f(-1.0,-1.0, 0.0);
		glEnd();

		if(rut/333 > 15) {
			glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
			glLoadIdentity();
			glTranslatef(0.0, 0.0, -2.0);
			bindtex(3);
			glBegin(GL_QUADS);
			glTexCoord2f(0.0, 0.0); glVertex3f(-1.0, 1.0, 0.0);
			glTexCoord2f(1.0, 0.0); glVertex3f( 1.0, 1.0, 0.0);
			glTexCoord2f(1.0, 1.0); glVertex3f( 1.0,-1.0, 0.0);
			glTexCoord2f(0.0, 1.0); glVertex3f(-1.0,-1.0, 0.0);
			glEnd();
		}
		if(rut/333 > 20) {
			glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
			glLoadIdentity();
			glTranslatef(0.0, 0.0, -4.0+sin(rut/10)*3);
			bindtex(4);
			glBegin(GL_QUADS);
			glTexCoord2f(0.0, 0.0); glVertex3f(-1.0, 1.0, 0.0);
			glTexCoord2f(1.0, 0.0); glVertex3f( 1.0, 1.0, 0.0);
			glTexCoord2f(1.0, 1.0); glVertex3f( 1.0,-1.0, 0.0);
			glTexCoord2f(0.0, 1.0); glVertex3f(-1.0,-1.0, 0.0);
			glEnd();
		}
		if(rut/333 > 22) {
			exit(0);
		}
	}		

	glutSwapBuffers();
}

void Timer(int value)
{
	static int frame = 0, time = 0, timebase = 0, fps;
	glutPostRedisplay();
	frame++;
	rut = time/3;
	time = glutGet(GLUT_ELAPSED_TIME);
	glutTimerFunc(0, Timer, 0);
	if(frame > 100) {
		printf("FPS: %03d\tTIME: %0.5f s\n",
					 frame*1000/(time-timebase),
					 rut/333);
		timebase = time;
		frame = 0;
	}
	MikMod_Update();
}

void reshape(int w, int h)
{
	/* Diving on zero si teh suck */
	if(h == 0) {
		h = 1;
	}
	glViewport(0.0, 0.0, (GLsizei)w, (GLsizei)h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective (110.0f, (GLfloat) w / (GLfloat) h, 0.1f,100.0f);
	glMatrixMode(GL_MODELVIEW);
}

void key(unsigned char key, int x, int y)
{
	if(key == 27) { /* clean up shit and exit if esc is pressed */
		exit(0);
	}
}

int main(int argc, char *argv[])
{
		glutInit(&argc, argv);
		glutInitDisplayMode(GLUT_DOUBLE | GLUT_DEPTH | GLUT_RGBA);
		glutInitWindowPosition(0, 0);
		glutCreateWindow(argv[0]);
		glutSetCursor(GLUT_CURSOR_NONE);
		init();
		glutDisplayFunc(display);
		glutReshapeFunc(reshape);
		glutTimerFunc(30, Timer, 0);
		glutKeyboardFunc(key);
		glutFullScreen();
		load_textures();
		glutMainLoop(); 
		return 0;
}

